# table_convert.rb  ver 1.1 2008.10.30
  # ^u؂̕\ӏX^C or Ă悱t]ɕϊ
  # Copyright (C) T. Yoshiizumi, 2008 All rights reserved.

$KCODE = 'SJIS'

# ]ȋ󔒂F\̃ZɓKp
def delete_space(s)
  s = s.sub(/[ @]+$/, "")  # ̋󔒂
  s.sub!(/^[ @]+/, "")  # 擪̋󔒂
  s.gsub!(/([^ @][ @]+)+[^ @]$|([^ @][ @]+){2,}[^ @]/) {|mp|  # ̋󔒂
    mp = mp.gsub(/[ @]+/, "")
  }
  s.gsub!(/( |@){3,}/, "\\1\\1")  # Rȏ̋󔒂̈k
  return s
end

# s^uR[hŕB]vȋ󔒂͍폜
def separate_tab(l)
  w = l.split(/\t/)
  for i in 0..(w.size-1)
    w[i] = delete_space(w[i])
  end
  return w
end

# '.~'Ŏn܂sO̍sƃZǍʂԂ
def combine_line(tbl)
  wtbl = []
  while w = tbl.shift
    unless w[0] =~ /^\.\~/
      wtbl << w
      next
    end
    w[0].sub!(/^\.\~/, "")
    if wtbl.size < 1
      wtbl << w
      next
    end
    item = wtbl.pop
    for i in 0..(w.size-1)
      item[i] = ''  if item[i] == nil
      if item[i] != '' and w[i] != '' and $separate_opt != 'del'
        item[i] = item[i] + "|" + w[i]
      else
        item[i] = item[i] + w[i]
      end
    end
    wtbl.push(item)
  end
  tbl.clear
  while w = wtbl.shift
    tbl << w
  end
end

# \ӏɕϊ
def table_to_list(tbl)
  if tbl.size < 1
    return []
  end
  if tbl.size < 2
    w = tbl.shift
    return [w.join("\t")]
  end
  combine_line(tbl)
  item = tbl.shift
  if tbl.size < 1
    return [item.join("\t")]
  end
  item_max = 0
  item.each {|i|  item_max=i.length if i.length > item_max}
  item_max += 3  # 'F 't镪̂RoCgZ
  item_max = 50  if item_max > 50
  fmt = sprintf("%%-%ds%%s", item_max)
  output = ['---Eӏ']
  tbl.each {|tt|
    for i in 0..(tt.size-1)
      next  if tt[i] == ''
      if item[i] == nil or item[i] == ''
        output << sprintf(fmt, "", tt[i])
        next
      end
      output << sprintf(fmt, item[i] + "F ", tt[i])
    end
    output << ''
  }
  while output[(output.size-1)] == ''
    output.pop
  end
  output << '---܂ŁEӏ'
  return output
end

# \Ă悱t]
def table_reverse(tbl)
  if tbl.size < 1
    return []
  end
  if tbl.size < 2
    w = tbl.shift
    return [w.join("\t")]
  end
  combine_line(tbl)
  if tbl.size < 2
    w = tbl.shift
    return [w.join("\t")]
  end
  tnf = 0
  tbl.each {|i|
    tnf = i.size  if i.size > tnf
  }
  if tnf < 2
    return tbl
  end
  tr = tbl.size - 1
  tnf -= 1
  output = ['---\Et]']
  j = 0
  while j <= tnf
    s = ''
    i = 0
    while i <= tr
      unless tbl[i][j]
        s = s + "\t"
      else
        s = sprintf("%s%s\t", s, tbl[i][j])
      end
      i += 1
    end
    s = s.sub(/\t$/, "")
    unless s =~ /^\t+$|^$/
      output << s
    end
    j += 1
  end
  while output[(output.size-1)] == '' or output[(output.size-1)] =~ /^\t+$/
    output.pop
  end
  output << '---\܂ŁEt]'
  return output
end

# \̕ϊ
def table_convert(tbl, opt)
  # 悸Aǂ̕\ɂʂ擪̋󗓂
  count = 256  # Œ󗓐o
  tbl.each {|tt|
    for i in 0..(tt.size-1)
      if tt[i] == ''
        next
      elsif i == 0 and tt[i] == '.~'
        next
      else
        break
      end
    end
    if i < count
      count = i
    end
  }
  if count > 0  # ʂ̐擪󗓂
    for i in 0..(tbl.size-1)
      head_mark='';  head_mark='.~' if tbl[i][0] == '.~'
      for j in 0..(count-1)
        tbl[i].shift
      end
      tbl[i][0] = head_mark + tbl[i][0]
    end
  end

  # \̕ϊ
  if opt.downcase == 'g'
    output = table_reverse(tbl)
  elsif opt.downcase == 'k'
    output = table_to_list(tbl)
  else
    combine_line(tbl)
    output = []
    tbl.each {|tt|
      for i in 0..(tt.size-1)
        tt[i] = delete_space(tt[i])
      end
      ttj = tt.join("\t")
      unless ttj =~ /^\t+$|^$/
        output << ttj
      end
    }
  end
  return output
end

## main
out_array = []
tbl = []
opt = 'n'
$separate_opt = 'del'
$combine_group = 0
for fname in ARGV
  if fname =~ /^-/
    if fname =~ /^-g/i
      opt = 'g'
    elsif fname =~ /^-k/i
      opt = 'k'
    elsif fname =~ /^-n/i
      opt = 'n'
    end
    next
  end
  next  unless test(?f, fname)
  infile = open(fname, "r")  rescue  next
  out_array.clear
  tbl.clear
  tbl_in = 0
  while l = infile.gets
    l.chomp!
    l.sub!(/[ @]+$/, "")
    next  if l =~ /^---\(|܂)Et]$/
    if l.downcase =~ /^\.([gkn])$/  # ߍݎ̃IvVo
      opt = $1
      next
    end
    if l.downcase =~ /^\.(del|add)\|$/  # ߍݎ̃Zp[gIvV
      $separate_opt = $1
      next
    end
    if l =~ /^\.\~(\d+)$/
      n = $1.to_i
      $combine_group = n  if n > 0
      next
    end
    if l =~ /^\.!/
      l.sub!(/^\.!/, "")
      l.gsub!(/\t+/, "@")
    end
    if tbl_in == 0 and l =~ /\t/  # \̐擪šo
      tbl_in = 1
      tbl.clear
      if $combine_group > 0
        r = tbl.size % $combine_group
        if r > 0
          l = ".~" + l
        end
      end
      tbl << separate_tab(l)
      next
    end
    if tbl_in == 1
      if l =~ /\t/  # ^uR[h܂ލśAƂ\Ƃ݂Ȃ
        if $combine_group > 0
          r = tbl.size % $combine_group
          if r > 0
            l = ".~" + l
          end
        end
        tbl << separate_tab(l)
      elsif l =~ /^$|^\#\#\d|^\[.+\]$/  # \I
        out_array << table_convert(tbl, opt)
        tbl.clear
        $combine_group = 0
        tbl_in = 0
        out_array << l
      else  # \̏I肪oȂ͕\
        if $combine_group > 0
          r = tbl.size % $combine_group
          if r > 0
            l = ".~" + l
          end
        end
        tbl << separate_tab(l)
      end
    else  # \ɑȂśÂ܂܏o
      out_array << l
    end
  end
  infile.close
  if tbl.size > 0
    out_array << table_convert(tbl, opt)
    tbl.clear
  end
  out_fname = fname.sub(/\.[a-z]+$/i, "").sub(/!+$/, "") + "!.txt"
  outfile = open(out_fname, "w")
  out_array.each {|i|  outfile.puts i}
  outfile.close
end
